require 'soar_sc/rack/router/http_method'

module SoarSc
  module Rack
    class Router

      module BuilderSyntax

        def map(path, app)
          add_route(Route.new(HttpMethod::ANY, path, app))
        end

        def get(path, app)
          add_route(Route.new(HttpMethod::GET, path, app))
        end

        def post(path, app)
          add_route(Route.new(HttpMethod::POST, path, app))
        end

        def put(path, app)
          add_route(Route.new(HttpMethod::PUT, path, app))
        end

        def delete(path, app)
          add_route(Route.new(HttpMethod::DELETE, path, app))
        end

        def options(path, app)
          add_route(Route.new(HttpMethod::OPTIONS, path, app))
        end

        def head(path, app)
          add_route(Route.new(HttpMethod::HEAD, path, app))
        end

        def trace(path, app)
          add_route(Route.new(HttpMethod::TRACE, path, app))
        end

        def connect(path, app)
          add_route(Route.new(HttpMethod::CONNECT, path, app))
        end

      end

    end
  end
end
