module SoarSc
  module Rack
    class Router

      class DuplicateRouteError < RuntimeError
        def self.for_route(route)
          new("Duplicate route for method #{route.method} on #{route.path}")
        end
      end

      class InvalidRouteError < RuntimeError; end

      class InvalidPathError < InvalidRouteError; end

      class InvalidParameterError < InvalidPathError; end

      class InvalidMethodError < InvalidRouteError; end

      class InvalidActionError < InvalidRouteError; end

    end
  end
end
